package org.processmining.glueminer.plugins;

import java.util.ArrayList;
import java.util.List;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginCategory;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginQuality;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.framework.util.ui.wizard.ListWizard;
import org.processmining.framework.util.ui.wizard.ProMWizardDisplay;
import org.processmining.framework.util.ui.wizard.ProMWizardStep;
import org.processmining.glueminer.algorithms.GeneratePetrinet;
import org.processmining.glueminer.dialogs.PetrinetGenerationWizardStep;
import org.processmining.glueminer.models.GeneratedPetrinet;
import org.processmining.glueminer.parameters.GeneratePetrinetParameters;

@Plugin(name = "Generate Petri net with random structure", level = PluginLevel.NightlyBuild, parameterLabels = { }, returnLabels = { "Generated Petri net" }, returnTypes = { GeneratedPetrinet.class }, help = "No help", quality = PluginQuality.VeryGood, categories = {
		PluginCategory.Discovery })
public class GeneratePetrinetPlugin {
	@UITopiaVariant(affiliation = "PADS", author = "Alessandro Berti", email = "a.berti@pads.rwth-aachen.de")
	@PluginVariant(requiredParameterLabels = { })
	public static GeneratedPetrinet generatePetrinet(UIPluginContext context) {
		GeneratePetrinetParameters parameters;
		
		PetrinetGenerationWizardStep wizardStep = new PetrinetGenerationWizardStep();
		List<ProMWizardStep<GeneratePetrinetParameters>> wizStepList = new ArrayList<>();
		wizStepList.add(wizardStep);
		ListWizard<GeneratePetrinetParameters> listWizard = new ListWizard<>(wizStepList);
		
		parameters = ProMWizardDisplay.show(context, listWizard, new GeneratePetrinetParameters());
		//parameters = new GeneratePetrinetParameters();
		
		GeneratePetrinet generatePetrinet = new GeneratePetrinet(context, parameters);	
		GeneratedPetrinet generatedNet = generatePetrinet.generatePetrinet();
		
		return generatedNet;
	}
}
